%define subrel %{nil}

%define as_major 5
%define as_minor 2
%define as_rev 0
%define jbossas_version %{as_major}.%{as_minor}.%{as_rev}

%define jms_option_rel 1

%define jbossdir %{_localstatedir}/lib/jbossas
%define jbhomedir %{_datadir}/jbossas
%define jbjavadir %{_javadir}/jbossas

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

# hq_client is used to pack client files either here or in jbossas
%bcond_without hq_client

Summary:       JBossas Hornetq
Name:          jbossas-hornetq
Version:       %{jbossas_version}
Release:       6%{?dist}
Epoch:         0
License:       LGPL
Group:         Development/Installer
URL:           http://www.jboss.org/

BuildRequires:	ant
BuildRequires:	jpackage-utils,zip,unzip
BuildRequires:	hornetq >= 2.2.24
BuildRequires:	jbossas-zip = %{as_major}.%{as_minor}.%{as_rev}
BuildRequires:	netty

Requires:	hornetq >= 2.2.24
Requires:	hornetq-native >= 0:2.2.11
Requires:	netty >= 3.2.5

Provides:	jbossas-jms-provider = %{epoch}:%{version}-%{jms_option_rel}

BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:    noarch

%description
This package is a container for the JBossas Hornetq files.

%package backup
Summary:     Backup profiles of %{name}.
Group:       Development
Requires:    %{name} = %{epoch}:%{version}-%{release}

%description backup
Backup profiles of %{name}.

%package examples
Summary:        Examples for %{name}
Group:          Development/Documentation

%description examples
%{summary}.

%prep

%build
mkdir jbossas-hornetq-%{as_major}.%{as_minor}
pushd jbossas-hornetq-%{as_major}.%{as_minor}
 unzip -q %{_javadir}/jbossas-fordev/jbossas-%{as_major}.%{as_minor}.%{as_rev}*-withauth.zip

  unzip -q %{_javadir}/jbossas-fordev/jbossas-%{as_major}.%{as_minor}.%{as_rev}*-hornetq.zip
popd

export JBOSS_HOME=$(pwd)/jbossas-hornetq-%{as_major}.%{as_minor}/jboss-as

# Run hornetq installer from JBOSS_HOME/extras/hornetq
pushd ${JBOSS_HOME}/extras/hornetq

# Add option to create backup profiles
 ant -Dbackup=true install
popd

%install
rm -rf $RPM_BUILD_ROOT
export JBOSS_HOME=$(pwd)/jbossas-hornetq-%{as_major}.%{as_minor}/jboss-as

# Files to copy to /usr/share/java/jbossas (all built files)
install -dm 755 $RPM_BUILD_ROOT%{jbjavadir}
install ${JBOSS_HOME}/server/all/deployers/jbossws.deployer/jbossws-hornetq.jar $RPM_BUILD_ROOT%{jbjavadir}/jbossws-hornetq.jar
install ${JBOSS_HOME}/common/lib/hornetq-int.jar $RPM_BUILD_ROOT%{jbjavadir}/hornetq-int.jar

install -d -p -m 755 $RPM_BUILD_ROOT%{jbhomedir}/client
install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/common/lib
install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server
ln -s $(build-classpath hornetq/hornetq-bootstrap.jar) $RPM_BUILD_ROOT%{jbossdir}/common/lib/hornetq-bootstrap.jar
ln -s $(build-classpath hornetq/hornetq-core.jar) $RPM_BUILD_ROOT%{jbossdir}/common/lib/hornetq-core.jar
ln -s $(build-classpath hornetq/hornetq-jboss-as-integration.jar) $RPM_BUILD_ROOT%{jbossdir}/common/lib/hornetq-jboss-as-integration.jar
ln -s $(build-classpath hornetq/hornetq-jms.jar) $RPM_BUILD_ROOT%{jbossdir}/common/lib/hornetq-jms.jar
ln -s $(build-classpath hornetq/hornetq-logging.jar) $RPM_BUILD_ROOT%{jbossdir}/common/lib/hornetq-logging.jar
ln -sf %{jbjavadir}/hornetq-int.jar $RPM_BUILD_ROOT%{jbossdir}/common/lib/hornetq-int.jar
ln -s $(build-classpath netty.jar) $RPM_BUILD_ROOT%{jbossdir}/common/lib/netty.jar
%if %with hq_client
# hornetq-core-client.jar is installed by jbossas-client
ln -s $(build-classpath hornetq/hornetq-core-client.jar) $RPM_BUILD_ROOT%{jbhomedir}/client/hornetq-core-client.jar
# hornetq-jms-client.jar is installed by jbossas-client
ln -s $(build-classpath hornetq/hornetq-jms-client.jar) $RPM_BUILD_ROOT%{jbhomedir}/client/hornetq-jms-client.jar
%endif
ln -sf %{jbjavadir}/jbossws-hornetq.jar $RPM_BUILD_ROOT%{jbhomedir}/client/jbossws-hornetq.jar

install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/jbossas
for server in all default standard production; do
  install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/$server/props
  install ${JBOSS_HOME}/server/$server/conf/props/hornetq-roles.properties \
        $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/$server/props/hornetq-roles.properties
  install ${JBOSS_HOME}/server/$server/conf/props/hornetq-users.properties \
        $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/$server/props/hornetq-users.properties
  install ${JBOSS_HOME}/server/$server/conf/login-config.xml \
        $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/$server/login-config.xml
  install ${JBOSS_HOME}/server/$server/conf/jbossts-properties.xml \
        $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/$server/jbossts-properties.xml
done

# Re-install the config files for web profile, as they ended up in 
# jbossas-mesaging with the others (JBPAPP-4998)
  install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/web
  install ${JBOSS_HOME}/server/web/conf/login-config.xml \
        $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/web/login-config.xml
  install ${JBOSS_HOME}/server/web/conf/jbossts-properties.xml \
        $RPM_BUILD_ROOT%{_sysconfdir}/jbossas/web/jbossts-properties.xml

# Optimization loop added for 5.1.1-3
for server in all default production standard; do
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server/deployers
   install ${JBOSS_HOME}/server/$server/deployers/ejb-deployer-jboss-beans.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deployers/ejb-deployer-jboss-beans.xml
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/hornetq
   install ${JBOSS_HOME}/server/$server/deploy/hornetq/hornetq-configuration.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/hornetq/hornetq-configuration.xml
   install ${JBOSS_HOME}/server/$server/deploy/hornetq/hornetq-jboss-beans.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/hornetq/hornetq-jboss-beans.xml
   install ${JBOSS_HOME}/server/$server/deploy/hornetq/hornetq-jms.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/hornetq/hornetq-jms.xml
   install ${JBOSS_HOME}/server/$server/deploy/hornetq/jms-ds.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/hornetq/jms-ds.xml
   install ${JBOSS_HOME}/server/$server/deployers/hornetq-deployers-jboss-beans.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deployers/hornetq-deployers-jboss-beans.xml
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/jms-ra.rar/META-INF
   ln -s $(build-classpath hornetq/hornetq-ra.jar) $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/jms-ra.rar/hornetq-ra.jar
   install ${JBOSS_HOME}/server/$server/deploy/jms-ra.rar/META-INF/ra.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server/deploy/jms-ra.rar/META-INF/ra.xml
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server/deployers/jbossws.deployer
   ln -sf %{jbjavadir}/jbossws-hornetq.jar $RPM_BUILD_ROOT%{jbossdir}/server/$server/deployers/jbossws.deployer/jbossws-hornetq.jar

   # Installation of backup profiles
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/conf
   cp -pR ${JBOSS_HOME}/server/$server-backup/conf/** $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/conf/
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deploy/hornetq
   install ${JBOSS_HOME}/server/$server-backup/deploy/hornetq/*.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deploy/hornetq/
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deploy/security
   cp -pR ${JBOSS_HOME}/server/$server-backup/deploy/security/** $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deploy/security/
   install ${JBOSS_HOME}/server/$server-backup/deploy/*.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deploy/
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deployers
   install ${JBOSS_HOME}/server/$server-backup/deployers/*.xml $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deployers/
   install -d -p -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/lib
   cp -pR ${JBOSS_HOME}/server/$server-backup/lib $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/
   ln -s $(build-classpath hornetq/hornetq-ra.jar) $RPM_BUILD_ROOT%{jbossdir}/server/$server-backup/deploy/hornetq/
done

# eap example zip
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
pushd ${JBOSS_HOME}
zip -r hornetq-eap-examples.zip docs/examples/hornetq-examples
popd
install -m 644 ${JBOSS_HOME}/hornetq-eap-examples.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/hornetq-eap-examples.zip 
rm ${JBOSS_HOME}/hornetq-eap-examples.zip

%clean
rm -Rf $RPM_BUILD_ROOT

%pre
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{jbossdir} -g jboss jboss 2>/dev/null || :

%files
%defattr(0644,jboss,jboss,0755)
%dir %{jbjavadir}
%{_javadir}*/jbossas/*.jar
%dir %{jbhomedir}
%{_sysconfdir}/jbossas
%{jbossdir}/common
%{jbhomedir}/client
%{jbossdir}/server/all
%{jbossdir}/server/default
%{jbossdir}/server/production
%{jbossdir}/server/standard

%files backup
%defattr(0644,jboss,jboss,0755)
%{jbossdir}/server/all-backup
%{jbossdir}/server/default-backup
%{jbossdir}/server/production-backup
%{jbossdir}/server/standard-backup

%files examples
%defattr(0644,root,root,0755)
%{_javadir}*/jbossas-fordev

%changelog
* Fri Jan 11 2013 Hui Wang <huwang@redhat.com> - 5.2.0-6
- Rebuild for jbossts replacement and EAP 5.2.0.ER6

* Mon Nov 19 2012 Hui Wang <huwang@redhat.com> - 5.2.0-5
- Rebuild for EAP 5.2.0.ER5

* Wed Nov 07 2012 Hui Wang <huwang@redhat.com> - 5.2.0-4
- Rebuild for EAP 5.2.0.ER4

* Mon Sep 10 2012 Martha Benitez <mbenitez@redhat.com> 5.2.0-3
- Rebuild to get latest jboss-seam2

* Wed Sep 05 2012 Hui Wang <huwang@redhat.com> - 5.2.0-2
- Rebuild for 5.2.0.ER2

* Thu Aug 23 2012 Martha Benitez <mbenitez@redhat.com> - 5.2.0-1
- Upgrade to 5.2.0

* Fri Jan 6 2012 Dustin Kut Moy Cheung <dcheung@redhat.com> - 0:5.1.2-9
- Fix for JBPAPP-7521 and JBPAPP-5791

* Thu Nov 10 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-8
- Rebuild

* Wed Nov 09 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.2-7
- Fix content of examples zip

* Wed Nov 09 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-6
- Add sub-package for examples

* Tue Nov 08 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-5
- Rebuild

* Thu Nov 03 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-4
- 5.1.2 ER2

* Mon Sep 19 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-3
- Rebuild

* Wed Sep 14 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.2-2
- Rebuild
 
* Wed Sep 14 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.2-1
- 5.1.2 build
 
* Wed Apr 27 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.1-4
- Add condition to pack client files either here or with jbossas
 
* Mon Apr 04 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.1-3.1
- Add R jbossas-hornetq to backup sub-package

* Thu Mar 31 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.1-3
- Add backup profiles as a new sub-package

* Tue Mar 29 2011 Fernando Nasser <fnasser@redhat.com> - 0:5.1.1-2
- Upgrade hornetq to 2.2.2.GA

* Thu Mar 17 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.1-1.1
- Upgrade to 5.1.1
- Upgrade hornetq to 2.2.1.GA

* Thu Mar 10 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-16.1
- Rebuild

* Thu Sep 02 2010 Fernando Nasser <fnasser@redhat.com> - 0:5.1.0-16
- Re-install the config files for web profile, as they ended up in 
  jbosas-mesaging with the others (JBPAPP-4998)

* Wed Sep 01 2010 Fernando Nasser <fnasser@redhat.com> - 0:5.1.0-15
- Replicate change from Andy Taylor to the installation script for
  JBPAPP-4489 - added tx recovery config for hornetq

* Wed Sep 01 2010 Permaine Cheung <pcheung@redhat.com> - 0:5.1.0-14
- Fix location of hornetq-roles.properties (JBPAPP-4817)

* Mon Aug 30 2010 Martha Benitez <mbenitez@redhat.com> 0:5.1.0-13
- Rebuild

* Fri Aug 27 2010 Fernando Nasser <fnasser@redhat.com> - 0:5.1.0-12
- Rebuild

* Fri Aug 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:5.1.0-11
- Rebuild

* Fri Aug 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:5.1.0-10
- Rebuild

* Wed Aug 11 2010 Permaine Cheung <pcheung@redhat.com> - 0:5.1.0-9
- Fix JBPAPP-4821 - Add hornetq stuff in production config

* Wed Jul 21 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-8
- Add creation of jboss group and user
- Change default permissions of main package

* Thu Jul 15 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-7
- Add R hornetq-native

* Mon Jul 05 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-6
- Remove installation of symlinks for hornetq-core-client.jar and hornetq-jms-client.jar in client directory (installed by jbossas-client)

* Wed Jun 30 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-5
- Change location of conf dir

* Wed Jun 30 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-4
- Fix Provides to specify a unique build
- Adjust version assignments

* Mon Jun 28 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-3
- Fix location of jbossws-hornetq.jar

* Thu Jun 24 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-2
- Fix location of hornetq jar files

* Wed Jun 23 2010 Martha Benitez <mbenitez@redhat.com> 0:5.1.0-1
- First build
